"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

function _default(babel) {
  var t = babel.types;
  return {
    name: 'elfin-routeNamesChain',
    visitor: {
      MemberExpression: {
        exit: function exit(path) {
          if (!path.hub) return;
          var file = path.hub.file;
          var node = path.node; // 是以属性调用的形式使用 RouteNamesChain.xxx

          if (!t.isIdentifier(path.node.object, {
            name: 'RouteNamesChain'
          })) return;
          var result = '';
          var property = node.property; // 是否自定义了 RouteNamesChain 变量

          if (file.scope.getBinding('RouteNamesChain') || !property) return;
          var preParent = null;
          var parent = path; // 要由大写字母开头

          while (parent && t.isIdentifier(parent.node.property) && /^[A-Z].*/.test(parent.node.property.name)) {
            result += "".concat(parent.node.property.name, "-");
            preParent = parent;
            parent = parent.findParent(function (temp) {
              return temp.isMemberExpression();
            });
          }

          if (preParent) {
            preParent.replaceWith(t.stringLiteral(result.slice(0, -1)));
          }
        }
      }
    }
  };
}

module.exports = exports.default;